/*
 * exmms by Boris (chris@darkrock.co.uk)
 * under GPL, you know the rules and regs.
 * 
 * have fun.
 */

#include <glib.h>
#include <xmms/xmmsctrl.h>
#include "epplet.h"

Epplet_gadget b_close, b_pause, b_play, b_next, b_previous, b_stop, b_help; /* buttons */
Epplet_gadget label1;                       /* labels  */
Epplet_gadget volume_master, distance; 
int songPos = 0;
int vol = 0;
gint xmms_session = 0, current_time = 0, current_volume = 0;
 
static void timer_cb( void *data );
static void close_cb( void *data );
static void in_cb( void *data, Window  w );
static void out_cb( void *data, Window w );
static void play_cb( void *data );
static void pause_cb( void *data );
static void stop_cb( void *data );
static void next_cb( void *data );
static void previous_cb( void *data );
static void set_volume( void *data );
static void set_position( void *data );

/* start functions */
static void timer_cb( void *data )
{
   gint playlist_pos;
   gint pos;
   
   if( xmms_remote_is_running( xmms_session ) && (xmms_remote_is_playing( xmms_session ) || xmms_remote_is_paused( xmms_session )) )
   {
      playlist_pos = xmms_remote_get_playlist_time( xmms_session, xmms_remote_get_playlist_pos(xmms_session) );
      pos = xmms_remote_get_output_time( xmms_session );
      songPos = (pos * 100) / playlist_pos;
      Epplet_gadget_data_changed( distance );
   }
   
   Epplet_timer( timer_cb, NULL, 0.5, "TIMER" );   
   data = NULL;
}

static void close_cb(void *data)
{
   Epplet_unremember();
   Esync();
   Epplet_cleanup();
   data = NULL;
   exit(0);
}

static void play_cb( void *data )
{
   if( !xmms_remote_is_running( xmms_session ) )
   {
      Epplet_run_command( "xmms &" );
   }
   xmms_remote_play( xmms_session );
}

static void pause_cb( void *data )
{
   xmms_remote_pause( xmms_session );
}

static void stop_cb( void *data )
{
   xmms_remote_stop( xmms_session );
}

static void next_cb( void *data )
{
   xmms_remote_playlist_next( xmms_session );
}

static void previous_cb( void *data )
{
   xmms_remote_playlist_prev( xmms_session );
}

static void set_volume( void *data )
{
   xmms_remote_set_volume( xmms_session, vol, vol );
}

static void set_position( void *data )
{
   gint playlist_pos;
   
   if( xmms_remote_is_running( xmms_session ) && (xmms_remote_is_playing( xmms_session ) || xmms_remote_is_paused( xmms_session )) )
   {
      playlist_pos = xmms_remote_get_playlist_time( xmms_session, xmms_remote_get_playlist_pos(xmms_session) );
      xmms_remote_jump_to_time(xmms_session, ((songPos * playlist_pos) / 100) + 5 );
   }
}
   
   
static void in_cb(void *data, Window w)
{
   return;
   data = NULL;
   w = (Window) 0;
}

static void out_cb(void *data, Window w)
{
   return;
   data = NULL;
   w = (Window) 0;
}

int main(int argc, char **argv)
{
   Epplet_Init( "E-Xmms", "0.2", "Enlightenment XMMS Remote Control", 3, 3, argc, argv, 0 );
   
   b_play  =    Epplet_create_button( NULL, NULL, 3, 2, 0, 0, "PLAY", 0, NULL,  play_cb, NULL );
   b_pause =    Epplet_create_button( NULL, NULL, 17, 2, 0, 0, "PAUSE", 0, NULL, pause_cb, NULL );
   b_stop =     Epplet_create_button( NULL, NULL, 31, 2, 0, 0, "STOP", 0, NULL, stop_cb, NULL );
   b_next  =    Epplet_create_button( NULL, NULL, 17, 13, 0, 0, "FAST_FORWARD", 0, NULL, next_cb, NULL );
   b_previous = Epplet_create_button( NULL, NULL, 3,13, 0, 0, "REWIND", 0, NULL, previous_cb, NULL );
   b_close =    Epplet_create_button( NULL, NULL, 31,  13, 0, 0, "CLOSE", 0, NULL, close_cb, NULL );
   
   distance = Epplet_create_hslider( 4, 25, 39, 0, 100, 1, 10, &songPos, set_position, &songPos );
   volume_master = Epplet_create_hslider( 4, 32, 39, 0, 100, 1, 10, &vol, set_volume, &vol );

   Epplet_gadget_show(label1 = Epplet_create_label(-4, 37, "exmms", 1));
  
   Epplet_gadget_show( b_pause );
   Epplet_gadget_show( b_play );
   Epplet_gadget_show( b_next );
   Epplet_gadget_show( b_previous );
   Epplet_gadget_show( b_stop );
   Epplet_gadget_show( distance );
   Epplet_gadget_show( volume_master );
   Epplet_gadget_show( b_close );
   
   Epplet_register_focus_in_handler(in_cb, NULL);
   Epplet_register_focus_out_handler(out_cb, NULL);

   Epplet_show();
   timer_cb(NULL);
   Epplet_Loop();
   return 0;
}
